
-- 1. How To Kill SPID For Specific Database

/*******************************************/ 
DECLARE @kill varchar ( 8000 ) = '' 
SELECT @kill = @kill + 'kill ' + convert ( varchar ( 5 ) , spid ) + ';' FROM master..sysprocesses 
WHERE dbid = db_id ( 'database_name' ) 
AND spid > 50 
AND spid <> @@spid 

EXEC ( @kill ) ; 
/*******************************************/ 

-- 2. Procedure To Kill All SPID For Specific Database

/*******************************************/ 
CREATE PROCEDURE KILL_SPID 
( @db varchar ( 8000 ) ) 
AS 
----Created By: Saurabh Sinha
----Date: 26/Nov/2014
----Description: This sp can take 1 database as parameter and kill all spids on db
----SYNTAX: KILL_SPID ('db1')
BEGIN 
    DECLARE @kill varchar ( 8000 ) = '' 

    SELECT @kill = @kill + 'kill ' + convert ( varchar ( 5 ) , spid ) + ';' FROM master..sysprocesses 
    WHERE dbid = db_id ( rtrim ( ltrim ( @db ) ) ) 
    AND spid > 50 
    AND spid <> @@spid 

    SELECT @kill 

    EXEC ( @kill ) ; 
    SELECT 'All spid mention above are killed' 

END 
/*******************************************/ 

-- 3. Procedure To Kill All SPID For Multiple Database

/**************************************/ 
CREATE PROCEDURE KILL_SPID_ON_MULTIPLE_DB 
( @db varchar ( max ) ) 
AS 

----Created By: Saurabh Sinha
----Date: 26/Nov/2014
----Description: This sp can take any no. of databases as parameter seperated with comma and kill all 
----spids on MULTIPLE DB
----SYNTAX: KILL_SPID_ON_MULTIPLE_DB ('db1,db2,db3 , db4,db5')

BEGIN 
    --Declare  @db  varchar(8000) 
    DECLARE @db1 varchar ( 8000 ) 
    DECLARE @count int , @count1 int , @len int 
    DECLARE @kill varchar ( 8000 ) = '' 

    SELECT @count = len ( @db ) - len ( replace ( @db , ',' , '' ) ) 

    WHILE @count > - 1 
    BEGIN 
        SET @db1 = left ( @db , charindex ( ',' , @db + ',' ) - 1 ) 
        SET @db = stuff ( @db , 1 , charindex ( ',' , @db + ',' ) , '' ) 
        SET @count = @count - 1 
        SET @db1 = rtrim ( ltrim ( @db1 ) ) 
        SELECT @db1 

        SELECT @kill = @kill + 'kill ' + convert ( varchar ( 5 ) , spid ) + ';' FROM master..sysprocesses 
        WHERE dbid = db_id ( @db1 ) 
        AND spid > 50 
        AND spid <> @@spid 

        SELECT @kill 

        EXEC ( @kill ) ; 
    END 
END 
/**************************************/ 

-- 4. How To Kill All Spid For Multiple Databases

/**************************************/ 

DECLARE @db varchar ( 8000 ) , @db1 varchar ( 8000 ) 
DECLARE @count int , @count1 int , @len int 
DECLARE @kill varchar ( 8000 ) = '' 
SET @db = 'test1,test2, test3' 
SELECT @count = len ( @db ) - len ( replace ( @db , ',' , '' ) ) 

WHILE @count > - 1 
BEGIN 
    SET @db1 = left ( @db , charindex ( ',' , @db + ',' ) - 1 ) 
    SET @db = stuff ( @db , 1 , charindex ( ',' , @db + ',' ) , '' ) 
    SET @count = @count - 1 
    SET @db1 = rtrim ( ltrim ( @db1 ) ) 
    SELECT @db1 

    SELECT @kill = @kill + 'kill ' + convert ( varchar ( 5 ) , spid ) + ';' FROM master..sysprocesses 
    WHERE dbid = db_id ( @db1 ) 
    AND spid > 50 
    AND spid <> @@spid 

    SELECT @kill 

    EXEC ( @kill ) ; 
END 
/**************************************/